"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.retry = void 0;
function retry(policy) {
    class RetryPlugin {
        constructor() {
            this.attempts = 0;
        }
        async onError(req, err) {
            if ((err.statusCode >= 500 || !err.statusCode) && policy.retries > this.attempts) {
                this.attempts += 1;
                if (policy.delay) {
                    let wait = policy.delay;
                    if (policy.backoff) {
                        wait *= policy.backoff ** (this.attempts - 1);
                    }
                    await new Promise(r => setTimeout(r, wait));
                }
                return { retry: true };
            }
        }
    }
    return RetryPlugin;
}
exports.retry = retry;
