"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.timeout = void 0;
function timeout(ttl) {
    class TimeoutPlugin {
        async onRequest(req) {
            this.timer = setTimeout(() => req.abort(), ttl);
        }
        async onResponse(req, res) {
            clearTimeout(this.timer);
        }
        async onError(req, res) {
            clearTimeout(this.timer);
        }
    }
    return TimeoutPlugin;
}
exports.timeout = timeout;
